package com.maroontress.sanctuary;

import java.io.File;

/**
   ޥɥ饤ǻꤷץޤ
*/
public final class Options {

    /** ͣΥ󥹥 */
    private static Options theInstance;

    /** C++бΥإåե */
    private boolean cxxHeaderSupport;

    /** XClassδ쥯饹 */
    private String baseXClass;

    /** ϥǥ쥯ȥ */
    private File outputDir;

    /** ϥե */
    private File inputFile;

    /**
       󥹥󥹤ޤ

       @return ץ
    */
    public static Options getInstance() {
	if (theInstance == null) {
	    theInstance = new Options();
	}
	return theInstance;
    }

    /**
       ǥեȤΥץޤ
    */
    private Options() {
	cxxHeaderSupport = true;
	baseXClass = null;
	outputDir = new File(".");
	inputFile = null;
    }

    /**
       C++бΥإåե뤫ɤޤ

       @return C++бʤtrueǤʤfalse
    */
    public boolean getCXXHeaderSupport() {
	return cxxHeaderSupport;
    }

    /**
       C++бΥإåե뤫ɤꤷޤ

       @param cxxHeaderSupport C++бʤtrueǤʤfalse
    */
    public void setCXXHeaderSupport(final boolean cxxHeaderSupport) {
	this.cxxHeaderSupport = cxxHeaderSupport;
    }

    /**
       XClassδ쥯饹ޤ

       @return 쥯饹ꤵƤϤδʥ饹̾
       Ǥʤnull
    */
    public String getBaseXClass() {
	return baseXClass;
    }

    /**
       XClassδ쥯饹ꤷޤ

       @param baseXClass 쥯饹δʥ饹̾
    */
    public void setBaseXClass(final String baseXClass) {
	this.baseXClass = baseXClass;
    }

    /**
       ϥǥ쥯ȥޤ

       @return ϥǥ쥯ȥ
    */
    public File getOutputDir() {
	return outputDir;
    }

    /**
       ϥǥ쥯ȥꤷޤ

       @param dir ϥǥ쥯ȥ
    */
    public void setOutputDir(final String dir) {
	outputDir = new File(dir);
    }

    /**
       ϥեޤ

       @return ϥե
    */
    public File getInputFile() {
	return inputFile;
    }

    /**
       ϥեꤷޤ

       @param file ϥե
    */
    public void setInputFile(final String file) {
	inputFile = new File(file);
    }
}
